
# Contribution Guide

## Reporting Bugs
Having issues or want to report a bug? Email help@addthis.com.

## Oracle Contributor Agreement
Oracle requires that contributors to all of its open-source projects sign the <a href="http://www.oracle.com/technetwork/community/oca-486395.html">Oracle Contributor Agreement</a> and email or fax back the completed agreement.

## Dependencies
Make sure you have the following installed:
 - Node.js
 - npm
 - Git

Use npm to install the following:
 - gulp `npm install -g gulp`
 - karma `npm install -g karma`

## Installation
Get the source code by cloning to git repository via:
```
git clone https://github.com/oracle/official-addthis-angularjs
```

Navigate into the git repository and in stall all the needed dependencies via npm:
```
npm install
```

## Building
There are a few commands to help automate the development process

### <code>gulp watch</code>
Rebuilds things as files change

### <code>gulp build</code>
Builds everything, including documentation

### <code>gulp test</code>
Runs tests

### <code>gulp jslint</code>
Lints the JavaScript

### <code>gulp docs</code>
Builds just the documentaiton

### <code>node server.js</code>
Serves all the code, documentation and examples sites locally at `http://localhost:3002`

Built Code: http://localhost:3002/dist/official-addthis-angularjs.js
Documentation: http://localhost:3002/docs/
Test Reports: http://localhost:3002/test/reports/
Example Site 1: http://localhost:3002/examples/example1/
Example Site 2: http://localhost:3002/examples/example2/
Example Site 3: http://localhost:3002/examples/example3/
