// Karma configuration
// Generated on Wed Aug 31 2016 19:33:45 GMT-0400 (EDT)

module.exports = function(config) {
  config.set({

    // base path that will be used to resolve all patterns (eg. files, exclude)
    basePath: '',


    // frameworks to use
    // available frameworks: https://npmjs.org/browse/keyword/karma-adapter
    frameworks: ['jasmine'],


    // list of files / patterns to load in the browser
    files: [
      '../node_modules/angular/angular.js',
      '../node_modules/angular-ui-router/release/angular-ui-router.js',
      '../node_modules/angular-mocks/angular-mocks.js',
      '../dist/official-addthis-angularjs.js',
      '../examples/example3/**/*.js',
      'example3/**/*.js'
    ],


    // list of files to exclude
    exclude: [
    ],


    // preprocess matching files before serving them to the browser
    // available preprocessors: https://npmjs.org/browse/keyword/karma-preprocessor
    preprocessors: {
      '../examples/example3/**/*.js': 'coverage'
    },


    coverageReporter: {
      type : 'html',
      dir : 'reports/example3/coverage/'
    },

    htmlReporter: {
      outputDir: 'test/reports/example3/unit',

      // Optional
      pageTitle: 'Unit Tests',
      subPageTitle: 'addthis-angular module',
      groupSuites: true,
      useCompactStyle: true,
      useLegacyStyle: true,
      urlFriendlyName: true
    },

    // test results reporter to use
    // possible values: 'dots', 'progress'
    // available reporters: https://npmjs.org/browse/keyword/karma-reporter
    reporters: ['progress', 'html', 'coverage'],


    // web server port
    port: 9876,


    // enable / disable colors in the output (reporters and logs)
    colors: true,


    // level of logging
    // possible values: config.LOG_DISABLE || config.LOG_ERROR || config.LOG_WARN || config.LOG_INFO || config.LOG_DEBUG
    logLevel: config.LOG_INFO,


    // enable / disable watching file and executing tests whenever any file changes
    autoWatch: true,


    // start these browsers
    // available browser launchers: https://npmjs.org/browse/keyword/karma-launcher
    browsers: [
        //'Chrome'//,
//        'Firefox',
//        'Safari',
        'PhantomJS'
    ],


    // Continuous Integration mode
    // if true, Karma captures browsers, runs the tests and exits
    singleRun: false,

    // Concurrency level
    // how many browser should be started simultaneous
    concurrency: 1
  });
};
